class VoterController < ApplicationController
  layout 'main'
  require_dependency "voter"
  require_dependency "vote"
  require_dependency "election"

  def index
    if params[:urlpassword]
      password = params[:urlpassword]

      if @voter = FullVoter.find(:all,
        :conditions => [ "password = ?", password ] )[0]

        @voter.vote = Vote.new if @voter.vote.nil?
        @voter.vote.set_defaults! if @voter.vote.rankings.empty?

        @election = @voter.election
        
        # if the election is now finished 
        if @election.enddate < Time.now
          # compute and display results
    
          @results = @election.results
          @candidates = {}
          @election.candidates.each {|c| @candidates[c.id] = c}
          @names = @election.names_by_id
          
          @sidebar_content = render_to_string(:partial => 'results_sidebar')
          render :action => 'results'
        else
          @sidebar_content = render_to_string(:partial => 'vote_sidebar')
          render :action => 'full_vote'
        end
      elsif params[:urlpassword] 
        redirect_to :action => 'index'
      end
    end
  end

  def login
    if params[:vote] and params[:vote][:password]
      redirect_to votepassword_url( :action => 'index', :urlpassword => params[:vote][:password])
    else
      redirect_to :action => 'index'
    end
  end
  
  def pref_tables
    if authenticate
      @election = @voter.election
      @results = @election.results
      @candidates = {}
      @election.candidates.each {|c| @candidates[c.id] = c}
      @names = @election.names_by_id
      render :template => 'common/pref_tables', :layout => 'basic'
    else
      redirect_to :action => 'index'
    end
  end

  def details
    if authenticate
      @election = @voter.election
      @votes = @election.votes.select {|v| v.confirmed? }.randomize
      @voters = @votes.collect {|v| v.voter}.randomize
      render :action => 'details'
    else
      redirect_to :action => 'index'
    end
  end

  def review
    if authenticate
      @voter.vote.time = Time.now
      @voter.vote.save
      @voter.reload
    else
      redirect_to :action => 'index'
    end
  end

  def confirm
    if authenticate
      @voter.vote.confirm!
      render :action => 'thanks'
    else
      redirect_to :action => 'index'
    end
  end
  
  def reminder
    if params[:email]
      voter_array= FullVoter.find(:all, :conditions => ["email = ?", params[:email]])
      voter_array.delete_if {|voter| voter.election.active == 0}
      unless voter_array.empty?
        VoterNotify.deliver_reminder(voter_array)
      end
      render :action => 'reminder_sent'
    end
  end
  
  
  private
  def authenticate
    password = params[:id]
    @voter = FullVoter.find(:all, :conditions => [ "password = ?", password ] )[0]
  end
end

